<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleCustomImplicitAuxiliaryDynamics.cpp</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleCustomImplicitAuxiliaryDynamics_8cpp-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleCustomImplicitAuxiliaryDynamics.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<p>This example shows how to define dynamics with an implicit differential equation.</p>
<div class="fragment"><div class="line"><span class="comment">/* -------------------------------------------------------------------------- *</span></div>
<div class="line"><span class="comment"> * OpenSim Moco: exampleCustomImplicitAuxiliaryDynamics.cpp                   *</span></div>
<div class="line"><span class="comment"> * -------------------------------------------------------------------------- *</span></div>
<div class="line"><span class="comment"> * Copyright (c) 2019 Stanford University and the Authors                     *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Author(s): Christopher Dembia                                              *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may    *</span></div>
<div class="line"><span class="comment"> * not use this file except in compliance with the License. You may obtain a  *</span></div>
<div class="line"><span class="comment"> * copy of the License at http://www.apache.org/licenses/LICENSE-2.0          *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Unless required by applicable law or agreed to in writing, software        *</span></div>
<div class="line"><span class="comment"> * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,          *</span></div>
<div class="line"><span class="comment"> * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   *</span></div>
<div class="line"><span class="comment"> * See the License for the specific language governing permissions and        *</span></div>
<div class="line"><span class="comment"> * limitations under the License.                                             *</span></div>
<div class="line"><span class="comment"> * -------------------------------------------------------------------------- */</span></div>
<div class="line"> </div>
<div class="line"><span class="preprocessor">#include &lt;OpenSim/Moco/osimMoco.h&gt;</span></div>
<div class="line"> </div>
<div class="line"><span class="keyword">using namespace </span><a class="code" href="namespaceOpenSim.html">OpenSim</a>;</div>
<div class="line"> </div>
<div class="line"><span class="keyword">class </span>MyImplicitAuxiliaryDynamics : <span class="keyword">public</span> Component {</div>
<div class="line">    OpenSim_DECLARE_CONCRETE_OBJECT(MyImplicitAuxiliaryDynamics, Component);</div>
<div class="line"> </div>
<div class="line"><span class="keyword">public</span>:</div>
<div class="line">    OpenSim_DECLARE_PROPERTY(</div>
<div class="line">            default_foo, <span class="keywordtype">double</span>, <span class="stringliteral">&quot;Default value of the state variable foo.&quot;</span>);</div>
<div class="line">    OpenSim_DECLARE_PROPERTY(foo_dynamics_mode, std::string,</div>
<div class="line">            <span class="stringliteral">&quot;The dynamics mode for enforcing y y&#39; - 1 = 0. &quot;</span></div>
<div class="line">            <span class="stringliteral">&quot;Options: &#39;explicit&#39; or &#39;implicit&#39;. Default: &#39;explicit&#39;. &quot;</span>);</div>
<div class="line"> </div>
<div class="line">    OpenSim_DECLARE_OUTPUT(</div>
<div class="line">            statebounds_foo, SimTK::Vec2, getBoundsFoo, SimTK::Stage::Model);</div>
<div class="line">    OpenSim_DECLARE_OUTPUT(implicitresidual_foo, <span class="keywordtype">double</span>, getImplicitResidualFoo,</div>
<div class="line">            SimTK::Stage::Dynamics);</div>
<div class="line">    OpenSim_DECLARE_OUTPUT(implicitenabled_foo, <span class="keywordtype">bool</span>, getImplicitEnabledFoo,</div>
<div class="line">            SimTK::Stage::Model);</div>
<div class="line"> </div>
<div class="line">    MyImplicitAuxiliaryDynamics() {</div>
<div class="line">        setName(<span class="stringliteral">&quot;implicit_auxdyn&quot;</span>);</div>
<div class="line">        constructProperty_default_foo(0.5);</div>
<div class="line">        constructProperty_foo_dynamics_mode(<span class="stringliteral">&quot;explicit&quot;</span>);</div>
<div class="line">    }</div>
<div class="line">    MyImplicitAuxiliaryDynamics(std::string foo_dynamics_mode)</div>
<div class="line">            : MyImplicitAuxiliaryDynamics() {</div>
<div class="line">        set_foo_dynamics_mode(foo_dynamics_mode);</div>
<div class="line">    }</div>
<div class="line"> </div>
<div class="line">    SimTK::Vec2 getBoundsFoo(<span class="keyword">const</span> SimTK::State&amp;)<span class="keyword"> const </span>{</div>
<div class="line">        <span class="keywordflow">return</span> SimTK::Vec2(0, 3);</div>
<div class="line">    }</div>
<div class="line">    <span class="comment">// This function requires a state parameter because we use it in an Output;</span></div>
<div class="line">    <span class="comment">// however, we don&#39;t actually need the state.</span></div>
<div class="line">    <span class="keywordtype">bool</span> getImplicitEnabledFoo(<span class="keyword">const</span> SimTK::State&amp;)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }</div>
<div class="line">    <span class="comment">// We use &quot;residual&quot; to refer to the value of the implicit differential</span></div>
<div class="line">    <span class="comment">// equation function f(y, y&#39;) = y y&#39; - 1.</span></div>
<div class="line">    <span class="keywordtype">double</span> getImplicitResidualFoo(<span class="keyword">const</span> SimTK::State&amp; s)<span class="keyword"> const </span>{</div>
<div class="line">        <span class="comment">// If the dynamics mode is not implicit, then this function should not</span></div>
<div class="line">        <span class="comment">// be invoked, so we return NaN.</span></div>
<div class="line">        <span class="keywordflow">if</span> (!m_foo_dynamics_mode_implicit) { <span class="keywordflow">return</span> SimTK::NaN; }</div>
<div class="line">        <span class="keywordflow">if</span> (!isCacheVariableValid(s, <span class="stringliteral">&quot;implicitresidual_foo&quot;</span>)) {</div>
<div class="line">            <span class="comment">// Get the derivative control value.</span></div>
<div class="line">            <span class="keyword">const</span> <span class="keywordtype">double</span> derivative =</div>
<div class="line">                    getDiscreteVariableValue(s, <span class="stringliteral">&quot;implicitderiv_foo&quot;</span>);</div>
<div class="line">            <span class="comment">// Get the state variable value.</span></div>
<div class="line">            <span class="keyword">const</span> <span class="keywordtype">double</span> statevar = getStateVariableValue(s, <span class="stringliteral">&quot;foo&quot;</span>);</div>
<div class="line">            <span class="comment">// The dynamics residual: y y&#39; - 1 = 0.</span></div>
<div class="line">            <span class="keywordtype">double</span> residual = derivative * statevar - 1;</div>
<div class="line">            <span class="comment">// Update the cache variable with the residual value.</span></div>
<div class="line">            setCacheVariableValue(s, <span class="stringliteral">&quot;implicitresidual_foo&quot;</span>, residual);</div>
<div class="line">            markCacheVariableValid(s, <span class="stringliteral">&quot;implicitresidual_foo&quot;</span>);</div>
<div class="line">        }</div>
<div class="line">        <span class="keywordflow">return</span> getCacheVariableValue&lt;double&gt;(s, <span class="stringliteral">&quot;implicitresidual_foo&quot;</span>);</div>
<div class="line">    }</div>
<div class="line"> </div>
<div class="line"><span class="keyword">private</span>:</div>
<div class="line">    <span class="keywordtype">void</span> extendFinalizeFromProperties()<span class="keyword"> override </span>{</div>
<div class="line">        OPENSIM_THROW_IF_FRMOBJ(get_foo_dynamics_mode() != <span class="stringliteral">&quot;implicit&quot;</span> &amp;&amp;</div>
<div class="line">                                        get_foo_dynamics_mode() != <span class="stringliteral">&quot;explicit&quot;</span>,</div>
<div class="line">                Exception,</div>
<div class="line">                <span class="stringliteral">&quot;Expected foo_dynamics_mode to be &#39;implicit&#39; or &quot;</span></div>
<div class="line">                <span class="stringliteral">&quot;&#39;explicit&#39;, but got &#39;{}&#39;.&quot;</span>,</div>
<div class="line">                get_foo_dynamics_mode());</div>
<div class="line">        m_foo_dynamics_mode_implicit = get_foo_dynamics_mode() == <span class="stringliteral">&quot;implicit&quot;</span>;</div>
<div class="line">    }</div>
<div class="line">    <span class="keywordtype">void</span> extendInitStateFromProperties(SimTK::State&amp; s)<span class="keyword"> const override </span>{</div>
<div class="line">        Super::extendInitStateFromProperties(s);</div>
<div class="line">        setStateVariableValue(s, <span class="stringliteral">&quot;foo&quot;</span>, get_default_foo());</div>
<div class="line">    }</div>
<div class="line">    <span class="keywordtype">void</span> extendSetPropertiesFromState(<span class="keyword">const</span> SimTK::State&amp; s)<span class="keyword"> override </span>{</div>
<div class="line">        Super::extendSetPropertiesFromState(s);</div>
<div class="line">        set_default_foo(getStateVariableValue(s, <span class="stringliteral">&quot;foo&quot;</span>));</div>
<div class="line">    }</div>
<div class="line">    <span class="keywordtype">void</span> computeStateVariableDerivatives(<span class="keyword">const</span> SimTK::State&amp; s)<span class="keyword"> const override </span>{</div>
<div class="line">        <span class="keywordflow">if</span> (m_foo_dynamics_mode_implicit) {</div>
<div class="line">            <span class="comment">// In implicit mode, the state variable derivative is the value</span></div>
<div class="line">            <span class="comment">// of the discrete variable. We must set this for Moco to solve the</span></div>
<div class="line">            <span class="comment">// problem correctly.</span></div>
<div class="line">            <span class="keyword">const</span> <span class="keywordtype">double</span> derivative =</div>
<div class="line">                    getDiscreteVariableValue(s, <span class="stringliteral">&quot;implicitderiv_foo&quot;</span>);</div>
<div class="line">            setStateVariableDerivativeValue(s, <span class="stringliteral">&quot;foo&quot;</span>, derivative);</div>
<div class="line">        } <span class="keywordflow">else</span> {</div>
<div class="line">            <span class="keyword">const</span> <span class="keywordtype">double</span> statevar = getStateVariableValue(s, <span class="stringliteral">&quot;foo&quot;</span>);</div>
<div class="line">            setStateVariableDerivativeValue(s, <span class="stringliteral">&quot;foo&quot;</span>, 1.0 / statevar);</div>
<div class="line">        }</div>
<div class="line">    }</div>
<div class="line">    <span class="keywordtype">void</span> extendAddToSystem(SimTK::MultibodySystem&amp; system)<span class="keyword"> const override </span>{</div>
<div class="line">        Super::extendAddToSystem(system);</div>
<div class="line">        addStateVariable(<span class="stringliteral">&quot;foo&quot;</span>);</div>
<div class="line">        addDiscreteVariable(<span class="stringliteral">&quot;implicitderiv_foo&quot;</span>, SimTK::Stage::Dynamics);</div>
<div class="line">        addCacheVariable(</div>
<div class="line">                <span class="stringliteral">&quot;implicitresidual_foo&quot;</span>, <span class="keywordtype">double</span>(0), SimTK::Stage::Dynamics);</div>
<div class="line">    }</div>
<div class="line">    <span class="keywordtype">bool</span> m_foo_dynamics_mode_implicit;</div>
<div class="line">};</div>
<div class="line"> </div>
<div class="line"><span class="keywordtype">int</span> main() {</div>
<div class="line">    <span class="keywordflow">try</span> {</div>
<div class="line">        <span class="keywordtype">double</span> finalFooTimeStepping;</div>
<div class="line">        <span class="keywordtype">double</span> finalFooDircol;</div>
<div class="line">        <span class="comment">// Simulate the differential equation in explicit mode using one of</span></div>
<div class="line">        <span class="comment">// OpenSim&#39;s time-stepping integrators.</span></div>
<div class="line">        {</div>
<div class="line">            Model model;</div>
<div class="line">            model.addComponent(<span class="keyword">new</span> MyImplicitAuxiliaryDynamics(<span class="stringliteral">&quot;explicit&quot;</span>));</div>
<div class="line">            SimTK::State state = model.initSystem();</div>
<div class="line">            model.setStateVariableValue(state, <span class="stringliteral">&quot;/implicit_auxdyn/foo&quot;</span>, 1.0);</div>
<div class="line">            Manager manager(model, state);</div>
<div class="line">            state = manager.integrate(1.0);</div>
<div class="line">            finalFooTimeStepping =</div>
<div class="line">                    model.getStateVariableValue(state, <span class="stringliteral">&quot;/implicit_auxdyn/foo&quot;</span>);</div>
<div class="line">        }</div>
<div class="line">        <span class="comment">// Simulate the differential equation in implicit mode using Moco.</span></div>
<div class="line">        <span class="comment">// Because this problem does not have any cost terms or control</span></div>
<div class="line">        <span class="comment">// variables, Moco is solving an initial value problem (integrating</span></div>
<div class="line">        <span class="comment">// forward in time from a given initial state), not an optimal control</span></div>
<div class="line">        <span class="comment">// problem.</span></div>
<div class="line">        {</div>
<div class="line">            MocoStudy study;</div>
<div class="line">            <span class="keyword">auto</span>&amp; problem = study.updProblem();</div>
<div class="line">            <span class="keyword">auto</span> model = OpenSim::make_unique&lt;Model&gt;();</div>
<div class="line">            model-&gt;addComponent(<span class="keyword">new</span> MyImplicitAuxiliaryDynamics(<span class="stringliteral">&quot;implicit&quot;</span>));</div>
<div class="line">            problem.setModel(std::move(model));</div>
<div class="line">            problem.setTimeBounds(0, 1.0);</div>
<div class="line">            problem.setStateInfo(<span class="stringliteral">&quot;/implicit_auxdyn/foo&quot;</span>, {0, 3}, 1.0);</div>
<div class="line">            MocoSolution solution = study.solve();</div>
<div class="line">            <span class="keyword">const</span> <span class="keywordtype">int</span> N = solution.getNumTimes();</div>
<div class="line">            finalFooDircol = solution.getStatesTrajectory().getElt(N - 1, 0);</div>
<div class="line">        }</div>
<div class="line">        std::cout &lt;&lt; <span class="stringliteral">&quot;Final foo with time-stepping: &quot;</span> &lt;&lt; finalFooTimeStepping</div>
<div class="line">                  &lt;&lt; <span class="stringliteral">&quot;\nFinal foo with Moco: &quot;</span> &lt;&lt; finalFooDircol &lt;&lt; std::endl;</div>
<div class="line">    } <span class="keywordflow">catch</span> (<span class="keyword">const</span> std::exception&amp; e) {</div>
<div class="line">        std::cerr &lt;&lt; e.what() &lt;&lt; std::endl;</div>
<div class="line">        <span class="keywordflow">return</span> EXIT_FAILURE;</div>
<div class="line">    } <span class="keywordflow">catch</span> (...) { <span class="keywordflow">return</span> EXIT_FAILURE; }</div>
<div class="line">    <span class="keywordflow">return</span> EXIT_SUCCESS;</div>
<div class="line">}</div>
<div class="ttc" id="anamespaceOpenSim_html"><div class="ttname"><a href="namespaceOpenSim.html">OpenSim</a></div><div class="ttdoc">The Moco interface is contained within the OpenSim namespace.</div><div class="ttdef"><b>Definition:</b> ActivationCoordinateActuator.h:30</div></div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:39 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
